kernel-install: add default install scripts

Do the depmod in the kernel-install hooks, so hooks can produce/install
kernel modules and be part of the depmod.

Also move the basic boot loader entry creation and removal to a
plugin script.

If PRETTY_NAME is not defined in /etc/os-release, fallback to
PRETTY_NAME="Linux $KERNEL_VERSION".

Add documentation for everything in the man page.
This commit is contained in:
Harald Hoyer 2013-04-30 18:01:47 +02:00
parent c95686c6ed
commit 8f51399e75
5 changed files with 116 additions and 71 deletions

View file

@ -90,6 +90,7 @@ udevhomedir=$(udevlibexecdir)
udevrulesdir=$(udevlibexecdir)/rules.d udevrulesdir=$(udevlibexecdir)/rules.d
udevhwdbdir=$(udevlibexecdir)/hwdb.d udevhwdbdir=$(udevlibexecdir)/hwdb.d
catalogdir=$(prefix)/lib/systemd/catalog catalogdir=$(prefix)/lib/systemd/catalog
kernelinstalldir = $(prefix)/lib/kernel/install.d
# And these are the special ones for / # And these are the special ones for /
rootprefix=@rootprefix@ rootprefix=@rootprefix@
@ -291,11 +292,12 @@ bin_PROGRAMS = \
systemd-delta \ systemd-delta \
systemd-analyze systemd-analyze
bin_SCRIPTS = \ dist_bin_SCRIPTS = \
src/kernel-install/kernel-install src/kernel-install/kernel-install
EXTRA_DIST += \ dist_kernelinstall_SCRIPTS = \
src/kernel-install/kernel-install src/kernel-install/50-depmod.install \
src/kernel-install/90-loaderentry.install
rootlibexec_PROGRAMS = \ rootlibexec_PROGRAMS = \
systemd \ systemd \

View file

@ -84,7 +84,9 @@ along with systemd; If not, see <http://www.gnu.org/licenses/>.
<varlistentry> <varlistentry>
<term><command>add <replaceable>KERNEL-VERSION</replaceable> <replaceable>KERNEL-IMAGE</replaceable></command></term> <term><command>add <replaceable>KERNEL-VERSION</replaceable> <replaceable>KERNEL-IMAGE</replaceable></command></term>
<listitem> <listitem>
<para>calls every executable <para><command>kernel-install</command> creates the directory
<filename>/boot/<replaceable>MACHINE-ID</replaceable>/<replaceable>KERNEL-VERSION</replaceable>/</filename>
and calls every executable
<filename>/usr/lib/kernel/install.d/*.install</filename> and <filename>/usr/lib/kernel/install.d/*.install</filename> and
<filename>/etc/kernel/install.d/*.install</filename> with <filename>/etc/kernel/install.d/*.install</filename> with
the arguments the arguments
@ -93,21 +95,22 @@ add <replaceable>KERNEL-VERSION</replaceable> <filename>/boot/<replaceable>MACHI
</programlisting> </programlisting>
</para> </para>
<para><command>kernel-install</command> copies <para>The kernel-install plugin <filename>50-depmod.install</filename> runs depmod for the <replaceable>KERNEL-VERSION</replaceable>.</para>
<para>The kernel-install plugin <filename>90-loaderentry.install</filename> copies
<replaceable>KERNEL-IMAGE</replaceable> to <replaceable>KERNEL-IMAGE</replaceable> to
<filename>/boot/<replaceable>MACHINE-ID</replaceable>/<replaceable>KERNEL-VERSION</replaceable>/linux</filename>. <filename>/boot/<replaceable>MACHINE-ID</replaceable>/<replaceable>KERNEL-VERSION</replaceable>/linux</filename>.
</para> It also creates a boot loader entry according to the boot loader specification in
<para><command>kernel-install</command> also creates a boot
loader entry according to the boot loader specification in
<filename>/boot/loader/entries/<replaceable>MACHINE-ID</replaceable>-<replaceable>KERNEL-VERSION</replaceable>.conf</filename>. <filename>/boot/loader/entries/<replaceable>MACHINE-ID</replaceable>-<replaceable>KERNEL-VERSION</replaceable>.conf</filename>.
The title of the entry is the <replaceable>PRETTY_NAME</replaceable> parameter specified in <filename>/etc/os-release</filename>,
or "Linux <replaceable>KERNEL-VERSION</replaceable>", if unset.
If the file <filename>initrd</filename> is found next to the If the file <filename>initrd</filename> is found next to the
<filename>linux</filename> file, the initrd will be added to <filename>linux</filename> file, the initrd will be added to
the configuration.</para> the configuration.</para>
</listitem> </listitem>
</varlistentry> </varlistentry>
<varlistentry> <varlistentry>
<term><command>remove</command> <replaceable>KERNEL-VERSION</replaceable> <replaceable>KERNEL-IMAGE</replaceable></term> <term><command>remove <replaceable>KERNEL-VERSION</replaceable></command></term>
<listitem> <listitem>
<para>calls every executable <filename>/usr/lib/kernel/install.d/*.install</filename> <para>calls every executable <filename>/usr/lib/kernel/install.d/*.install</filename>
and <filename>/etc/kernel/install.d/*.install</filename> with the arguments and <filename>/etc/kernel/install.d/*.install</filename> with the arguments
@ -117,9 +120,10 @@ remove <replaceable>KERNEL-VERSION</replaceable> <filename>/boot/<replaceable>MA
</para> </para>
<para><command>kernel-install</command> removes the entire directory <para><command>kernel-install</command> removes the entire directory
<filename>/boot/<replaceable>MACHINE-ID</replaceable>/<replaceable>KERNEL-VERSION</replaceable>/</filename> <filename>/boot/<replaceable>MACHINE-ID</replaceable>/<replaceable>KERNEL-VERSION</replaceable>/</filename> afterwards.</para>
and the file
<filename>/boot/loader/entries/<replaceable>MACHINE-ID</replaceable>-<replaceable>KERNEL-VERSION</replaceable>.conf</filename></para> <para>The kernel-install plugin <filename>90-loaderentry.install</filename> removes the file
<filename>/boot/loader/entries/<replaceable>MACHINE-ID</replaceable>-<replaceable>KERNEL-VERSION</replaceable>.conf</filename>.</para>
</listitem> </listitem>
</varlistentry> </varlistentry>
@ -167,7 +171,7 @@ remove <replaceable>KERNEL-VERSION</replaceable> <filename>/boot/<replaceable>MA
<filename>/etc/os-release</filename> <filename>/etc/os-release</filename>
</term> </term>
<listitem> <listitem>
<para>The content of the file specifies the operating system id <replaceable>OS-ID</replaceable>.</para> <para>The content of the file specifies the operating system title <replaceable>PRETTY_NAME</replaceable>.</para>
</listitem> </listitem>
</varlistentry> </varlistentry>
</variablelist> </variablelist>

View file

@ -0,0 +1,8 @@
#!/bin/bash
# -*- mode: shell-script; indent-tabs-mode: nil; sh-basic-offset: 4; -*-
# ex: ts=8 sw=4 sts=4 et filetype=sh
[[ $1 == "add" ]] || exit 0
[[ $2 ]] || exit 1
exec depmod -a "$2"

View file

@ -0,0 +1,77 @@
#!/bin/bash
# -*- mode: shell-script; indent-tabs-mode: nil; sh-basic-offset: 4; -*-
# ex: ts=8 sw=4 sts=4 et filetype=sh
COMMAND="$1"
KERNEL_VERSION="$2"
BOOT_DIR_ABS="$3"
KERNEL_IMAGE="$4"
if [[ -f /etc/machine-id ]]; then
read MACHINE_ID < /etc/machine-id
fi
if ! [[ $MACHINE_ID ]]; then
exit 1
fi
BOOT_DIR="/$MACHINE_ID/$KERNEL_VERSION"
LOADER_ENTRY="/boot/loader/entries/$MACHINE_ID-$KERNEL_VERSION.conf"
if [[ $COMMAND == remove ]]; then
exec rm -f "$LOADER_ENTRY"
fi
if ! [[ $COMMAND == add ]]; then
exit 1
fi
if ! [[ $KERNEL_IMAGE ]]; then
exit 1
fi
if [[ -f /etc/os-release ]]; then
. /etc/os-release
fi
if ! [[ $PRETTY_NAME ]]; then
PRETTY_NAME="Linux $KERNEL_VERSION"
fi
if [[ -f /etc/kernel/cmdline ]]; then
readarray -t BOOT_OPTIONS < /etc/kernel/cmdline
fi
if ! [[ ${BOOT_OPTIONS[*]} ]]; then
readarray -t BOOT_OPTIONS < /proc/cmdline
fi
if ! [[ $BOOT_OPTIONS ]]; then
echo "Could not determine the kernel command line parameters." >&2
echo "Please specify the kernel command line in /etc/kernel/cmdline!" >&2
exit 1
fi
cp --preserve "$KERNEL_IMAGE" "$BOOT_DIR_ABS/linux" || {
echo "Could not copy '$KERNEL_IMAGE to '$BOOT_DIR_ABS/linux'." >&2
exit 1
}
mkdir -p "${LOADER_ENTRY%/*}" || {
echo "Could not create loader entry directory '${LOADER_ENTRY%/*}'." >&2
exit 1
}
{
echo "title $PRETTY_NAME"
echo "version $KERNEL_VERSION"
echo "machine-id $MACHINE_ID"
echo "options ${BOOT_OPTIONS[*]}"
echo "linux $BOOT_DIR/linux"
[[ -f $BOOT_DIR_ABS/initrd ]] && \
echo "initrd $BOOT_DIR/initrd"
} > "$LOADER_ENTRY" || {
echo "Could not create loader entry '$LOADER_ENTRY'." >&2
exit 1
}
exit 0

View file

@ -58,16 +58,6 @@ COMMAND="$1"
KERNEL_VERSION="$2" KERNEL_VERSION="$2"
KERNEL_IMAGE="$3" KERNEL_IMAGE="$3"
if [[ -f /etc/os-release ]]; then
. /etc/os-release
fi
if ! [[ $ID ]]; then
echo "Could not determine the distribution name from /etc/os-release." >&2
echo "Please specify ID=... in /etc/os-release. See man:os-release(5)" >&2
exit 1
fi
if [[ -f /etc/machine-id ]]; then if [[ -f /etc/machine-id ]]; then
read MACHINE_ID < /etc/machine-id read MACHINE_ID < /etc/machine-id
fi fi
@ -78,28 +68,12 @@ if ! [[ $MACHINE_ID ]]; then
exit 1 exit 1
fi fi
if [[ -f /etc/kernel/cmdline ]]; then
readarray -t BOOT_OPTIONS < /etc/kernel/cmdline
fi
if ! [[ ${BOOT_OPTIONS[*]} ]]; then
readarray -t BOOT_OPTIONS < /proc/cmdline
fi
if ! [[ $BOOT_OPTIONS ]]; then
echo "Could not determine the kernel command line parameters." >&2
echo "Please specify the kernel command line in /etc/kernel/cmdline!" >&2
exit 1
fi
if [[ ! $COMMAND ]] || [[ ! $KERNEL_VERSION ]]; then if [[ ! $COMMAND ]] || [[ ! $KERNEL_VERSION ]]; then
usage usage
exit 1 exit 1
fi fi
BOOT_DIR="/$MACHINE_ID/$KERNEL_VERSION" BOOT_DIR_ABS="/boot/$MACHINE_ID/$KERNEL_VERSION"
BOOT_DIR_ABS="/boot$BOOT_DIR"
LOADER_ENTRY="/boot/loader/entries/$MACHINE_ID-$KERNEL_VERSION.conf"
ret=0 ret=0
readarray -t PLUGINS < <( readarray -t PLUGINS < <(
@ -121,41 +95,23 @@ case $COMMAND in
} }
for f in "${PLUGINS[@]}"; do for f in "${PLUGINS[@]}"; do
[[ -x $f ]] && "$f" add "$KERNEL_VERSION" "$BOOT_DIR_ABS" if [[ -x $f ]]; then
((ret+=$?)) "$f" add "$KERNEL_VERSION" "$BOOT_DIR_ABS" "$KERNEL_IMAGE"
((ret+=$?))
fi
done done
cp --preserve "$KERNEL_IMAGE" "$BOOT_DIR_ABS/linux" || {
echo "Could not copy '$KERNEL_IMAGE to '$BOOT_DIR_ABS/linux'." >&2
exit 1
}
mkdir -p "${LOADER_ENTRY%/*}" || {
echo "Could not create loader entry directory '${LOADER_ENTRY%/*}'." >&2
exit 1
}
{
echo "title $PRETTY_NAME"
echo "version $KERNEL_VERSION"
echo "machine-id $MACHINE_ID"
echo "options ${BOOT_OPTIONS[*]}"
echo "linux $BOOT_DIR/linux"
[[ -f $BOOT_DIR_ABS/initrd ]] && \
echo "initrd $BOOT_DIR/initrd"
} > "$LOADER_ENTRY" || {
echo "Could not create loader entry '$LOADER_ENTRY'." >&2
exit 1
}
;; ;;
remove) remove)
for f in "${PLUGINS[@]}"; do for f in "${PLUGINS[@]}"; do
[[ -x $f ]] && "$f" remove "$KERNEL_VERSION" "$BOOT_DIR_ABS" if [[ -x $f ]]; then
((ret+=$?)) "$f" remove "$KERNEL_VERSION" "$BOOT_DIR_ABS"
((ret+=$?))
fi
done done
rm -rf "$LOADER_ENTRY" "$BOOT_DIR_ABS" rm -rf "$BOOT_DIR_ABS"
((ret+=$?))
;; ;;
*) *)
@ -164,6 +120,4 @@ case $COMMAND in
;; ;;
esac esac
((ret+=$?))
exit $ret exit $ret